#include <LiquidCrystal.h>
#include <EEPROM.h>
LiquidCrystal _lcd1(12, 11, 5, 4, 3, 2);
int _dispTempLength1=0;
boolean _isNeedClearDisp1;

int _gtv1;
int _gtv2; //Счет EEPROM
bool _gtv3; //При понижение напряжение мене 4,5 волт на выходе появляется импульс
int _gtv4;
int _disp1oldLength = 0;
int _disp2oldLength = 0;
bool _count1I = 0;
int _count1P = 0;
bool _trgrt1 = 0;
bool _trgrt1I = 0;
bool _trgrt2 = 0;
bool _trgrt2I = 0;
bool _SEEPR1OSN = 0;
bool _count2I = 0;
int _count2P = 0;
bool _trgrt3 = 0;
bool _trgrt3I = 0;
bool _bounse1S = 0;
bool _bounse1O = 0;
unsigned long _bounse1P = 0UL;
bool _trgr1 = 0;
bool _bounseInput6S = 0;
bool _bounseInput6O = 0;
unsigned long _bounseInput6P = 0UL;
bool _bounseInput10S = 0;
bool _bounseInput10O = 0;
unsigned long _bounseInput10P = 0UL;
void setup()
{
pinMode(10, INPUT);
digitalWrite(10, HIGH);
pinMode(6, INPUT);
digitalWrite(6, HIGH);

_lcd1.begin(16, 2);
_bounseInput10O =  digitalRead(10);
_bounseInput6O =  digitalRead(6);
}
void loop()
{if (_isNeedClearDisp1) {_lcd1.clear(); _isNeedClearDisp1= 0;}

bool  _bounceTmp6 =  (digitalRead (6));

if (_bounseInput6S) 
    {
     if (millis() >= (_bounseInput6P + 40)) 
         {_bounseInput6O= _bounceTmp6; _bounseInput6S=0;}
     }
else
    {
     if (_bounceTmp6 != _bounseInput6O )
         {_bounseInput6S=1; _bounseInput6P = millis();} 
      } 
bool  _bounceTmp10 =  (digitalRead (10));

if (_bounseInput10S) 
    {
     if (millis() >= (_bounseInput10P + 40)) 
         {_bounseInput10O= _bounceTmp10; _bounseInput10S=0;}
     }
else
    {
     if (_bounceTmp10 != _bounseInput10O )
         {_bounseInput10S=1; _bounseInput10P = millis();} 
      } 



if (1) {
_dispTempLength1 = ((((String("Prod= ")) + ((String(_gtv1)))))).length();
if (_disp1oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp1oldLength = _dispTempLength1;
_lcd1.setCursor(0, 0);
_lcd1.print((((String("Prod= ")) + ((String(_gtv1))))));
} else {
if (_disp1oldLength > 0) {_isNeedClearDisp1 = 1; _disp1oldLength = 0;} 
}
if (1) {
_dispTempLength1 = ((((String("Shch=")) + ((String(_gtv4)))))).length();
if (_disp2oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp2oldLength = _dispTempLength1;
_lcd1.setCursor(0, 1);
_lcd1.print((((String("Shch=")) + ((String(_gtv4))))));
} else {
if (_disp2oldLength > 0) {_isNeedClearDisp1 = 1; _disp2oldLength = 0;} 
}

if (_trgrt1) 
   { 
   if (! _count1I)  
      {
       _count1P = _count1P+1;
       _count1I = 1;
      }
   }
else
   {
   _count1I=0;
   }
if (!(_bounseInput6O)) _count1P = 0;
if (!(_bounseInput10O)) { if (_trgrt1I) { _trgrt1 = 0;} else {_trgrt1 = 1; _trgrt1I = 1;} } else {_trgrt1 = 0; _trgrt1I = 0;}; 
 _gtv1 = _count1P;
_gtv3 = ( (analogRead (0))) <= (400);
if (!(_bounseInput10O)) { if (_trgrt2I) { _trgrt2 = 0;} else {_trgrt2 = 1; _trgrt2I = 1;} } else {_trgrt2 = 0; _trgrt2I = 0;}; 
 if(_trgrt3){ if(!_SEEPR1OSN){ EEPROMWriteInt(0, _gtv4); _SEEPR1OSN=1;} }else{ if(_SEEPR1OSN){_SEEPR1OSN=0;}}

if (_trgrt2) 
   { 
   if (! _count2I)  
      {
       _count2P = _count2P+1;
       _count2I = 1;
      }
   }
else
   {
   _count2I=0;
   }
if (_trgr1) { if (_trgrt3I) { _trgrt3 = 0;} else {_trgrt3 = 1; _trgrt3I = 1;} } else {_trgrt3 = 0; _trgrt3I = 0;}; 
 bool  _bounceTmp1 = _gtv3;

if (_bounse1S) 
    {
     if (millis() >= (_bounse1P + 40)) 
         {_bounse1O= _bounceTmp1; _bounse1S=0;}
     }
else
    {
     if (_bounceTmp1 != _bounse1O )
         {_bounse1S=1; _bounse1P = millis();} 
      } 
if(0) _trgr1 = 0;
if(_bounse1O) _trgr1 = 1;
_gtv4 = (_count2P)+(_gtv2);
_gtv2 = (EEPROMReadInt(0));




}
int EEPROMReadInt(int p_address)
        {
        byte lowByte = EEPROM.read(p_address);
        byte highByte = EEPROM.read(p_address + 1);

        return ((lowByte << 0) & 0xFF) + ((highByte << 8) & 0xFF00);
        }
void EEPROMWriteInt(int p_address, int p_value)
       {
        byte lowByte = ((p_value >> 0) & 0xFF);
        byte highByte = ((p_value >> 8) & 0xFF);

        EEPROM.write(p_address, lowByte);
        EEPROM.write(p_address + 1, highByte);
        }
